(*
 * Coq code for the paper
 *
 *       A Syntactic Approach to Foundational Proof-Carrying Code
 *                            
 *
 *   by Zhong Shao, Valery Trifonov, Stefan Monnier, Nadeem A. Hamid, 
 *                          and Zhaozhong Ni
 *
 * (for Coq version 7.0 - 7.3)
 *)


(***************************************************************************)
(* Definition and lemmas of registers in TAL *)
(***************************************************************************)

(* This file must be compiled using coqc to talreg.vo because it is 
   required as such by tal.v, ie. type in the shell:
coqc talreg.v
 *)


Inductive Reg : Set := r0 : Reg | r1 : Reg | r2 : Reg | r3 : Reg | r4 : Reg
                    |  r5 : Reg | r6 : Reg | r7 : Reg | r8 : Reg | r9 : Reg
                    |  r10: Reg | r11 : Reg | r12 : Reg | r13 : Reg | r14 : Reg
                    |  r15: Reg | r16 : Reg | r17 : Reg | r18 : Reg | r19 : Reg
                    |  r20: Reg | r21 : Reg | r22 : Reg | r23 : Reg | r24 : Reg
                    |  r25: Reg | r26 : Reg | r27 : Reg | r28 : Reg | r29 : Reg
		    |  r30: Reg.

Lemma eqorneq_reg : (r,r':Reg) r=r' \/ ~r=r'.
Proof.
Intros.
Compare r r'.
Intros.
Left.
Auto.
Right.
Auto.
Save.


(***************************************************************************)


